<template>
  <div class="flex items-center col-grow">
    <q-btn
      round
      icon="drag_handle"
      class="column__drag-handle q-mr-sm"
      size="xs"
    />
    <q-select
      v-model="column.field"
      :disable="availableFields.length === 0"
      stack-label="Field"
      :options="availableFields"
      inverted-light
      color="white"
    />
    <q-input
      v-model="column.label"
      stack-label="Label"
      inverted-light
      color="white"
      class="q-ml-sm col-grow"
    />
    <q-input
      v-model="column.width"
      stack-label="Width"
      inverted-light
      color="white"
      type="number"
      :min="0"
      :max="100"
      class="q-ml-sm"
    />
    <q-select
      v-if="!!column.width"
      v-model="column.widthUnit"
      stack-label="Units"
      inverted-light
      color="white"
      class="q-ml-xs"
      :options="availableWidthUnits"
    />
    <q-select
      v-model="column.type"
      stack-label="Type"
      inverted-light
      color="white"
      class="q-ml-sm"
      :options="availableTypes"
    />
    <q-btn
      icon="build"
      round
      color="blue"
      class="q-ml-sm"
      @click="edit"
      :disable="!column.type"
    />
    <q-btn
      icon="delete"
      round
      color="red"
      class="q-ml-sm"
      @click="remove"
    />
  </div>
</template>

<script>
  import {
    availableCollectionColumnTypes,
    defaultCollectionColumnConfig,
  } from '../../../../../../utilities/migrateConfig';

  export default {
    name: 'collectionColumn',
    props: {
      column: {
        type: Object,
      },
      availableFields: {
        type: Array,
      },
    },
    methods: {
      edit() {
        this.$emit('edit');
      },
      remove() {
        this.$emit('remove');
      },
    },
    watch: {
      // eslint-disable-next-line func-names
      'column.type': function (type) {
        this.column.config = { ...defaultCollectionColumnConfig(type) };
      },
      // eslint-disable-next-line func-names
      'column.field': function (field, oldField) {
        if (this.column.label === oldField || !this.column.label) {
          this.column.label = field;
        }
      },
    },
    data() {
      return {
        availableWidthUnits: ['px', '%'].map((value) => ({
          value,
          label: value,
        })),
        availableTypes: availableCollectionColumnTypes,
      };
    },
  };
</script>

<style scoped>

</style>
